import MCF_BaseType from './base'



export default class MCF_Enum extends MCF_BaseType {
  constructor(definition) {
    super(definition)
    this.addValidations()
  }

  addValidations() {
    this.validations.isAvailable = function(value, definition) {
      const valueIsAvailable = definition.availableValues.reduce(function(isAvailable, availableValue) {
        if (value === availableValue) return true
        return isAvailable
      }, false)
      if (!valueIsAvailable) {
        throw new Error(`MCF-Objects ==> MCF_Enum validation: the value "${value}" isn't one of the next values, included in the field definition: ${definition.availableValues.toString()}`)
      }
    }
  }
}
