import MCF_BaseType from './base'


export default class MCF_Number extends MCF_BaseType {
  constructor(definition) {
    super(definition)
    this.addValidations()
  }

  addValidations() {
    this.validations.type = function(value) {
      if (typeof(value) !== 'number') {
        throw new Error(`MCF-Objects ==> MCF_Number validation: the type of the value ${value} isn't "number"`)
      }
    }

    for (const param in this.definition) {
      switch (param) {
      case 'max':
        this.validations.max = function(value, definition) {
          if (value > definition.max) {
            throw new Error(`MCF-Objects ==> MCF_Number validation: the value ${value} is higher than the maximum defined: ${definition.max}`)
          }
        }
        break
      case 'min':
        this.validations.min = function(value, definition) {
          if (value < definition.min) {
            throw new Error(`MCF-Objects ==> MCF_Number validation: the value ${value} is lower than the minimum defined: ${definition.min}`)
          }
        }
        break
      }
    }
  }
}
